const
remote  = require('electron').remote,
cp      = require('child_process'),

walker  = cp.fork('./walkerkHelper.js'),
OPT     = require('./options.js'),

appCloseBtn  = document.querySelector('#close'),
appStatusBar = document.querySelector('#status'),
startBtn     = document.querySelector('#startBtn'),
addBtn       = document.querySelector('#addBtn'),
pathsDiv     = document.querySelector('#paths'),
pathsDivHead = document.querySelector('#pathsHead'),
webview      = document.querySelector('webview');

let
debug = false,
dir   = dirObject,
dirs  = [],

prevStatusBarMsg = '',
appStatus    = OPT.STOPPED;

//webview.openDevTools();

appCloseBtn.addEventListener('click', e =>{
 const options = {
   type: 'warning',
   buttons: ['Yes', 'No'],
   message: 'Do you really want to quit?',
   title:'Duplicate Files Finder'
  }
 remote.dialog.showMessageBox(options, i => {
  if (i == 1) return;
  remote.getCurrentWindow().close();
 })
});

startBtn.addEventListener('click',()=>{
 debug&&console.log(appStatus);
	if (dirs.length === 0) return
	switch (appStatus){
  case OPT.STOPPED:
   startApp();
  break;
  case OPT.PAUSED:
   resumeApp();
  break;
  case OPT.STARTED:
  case OPT.RESUMED:
   pauseApp();
 }
});

addBtn.addEventListener('click', () =>{
 debug&&console.log(appStatus);
 	switch (appStatus){   
  case OPT.STOPPED:
   appStoppedAddBtnClicked();
  break;
  case OPT.DONE:
   appDoneAddBtnClicked();
  break;
  case OPT.PAUSED:
  case OPT.STARTED:
  case OPT.RESUMED:
   stopAppAddBtnClicked();
 }
});

function appStoppedAddBtnClicked(){
	let options = {
		properties: ['openDirectory', 'multiSelections'],
  title:'Duplicate Files Finder'
	}	
	remote.dialog.showOpenDialog(
 options, (paths) => {
		if (!paths) return
		paths.forEach(path =>{
			let isExist = dirs.some((dir) => {
				return dir.path == path
			})
			if (isExist){
				alert(path + ' already added in the list') 
				return;
			}
			new dir(path);
		})
	})
}
function appDoneAddBtnClicked(){
 const options = {
   type: 'warning',
   buttons: ['Yes', 'No'],
   message: 'Do you wan to start a new empty project?',
   title:'Duplicate Files Finder'
  }
 remote.dialog.showMessageBox(options, i => {
  if (i == 1) return;  
  walker.send({walker:OPT.RESET});
  dirs = [];
  pathsDiv.innerHTML = '';
  pathsDivHead.className = 'hide';
  addBtn.innerHTML = '<span class="icon-folder"></span>Add folder';
  startBtn.innerHTML = '<span class="icon-play"></span>Start';
  startBtn.disabled = false;
  appStatusBar.innerHTML = 'Ready';
  webview.style.height = '';
  webview.reload();
  appStatus = OPT.STOPPED;
 })
}
function stopAppAddBtnClicked(){
 const currAppStatus = appStatus;
 if (currAppStatus !== OPT.PAUSED){
  pauseApp();
 }
 const options = {
   type: 'warning',
   buttons: ['Yes', 'No'],
   message: 'Do you really want to cancel duplicate files search?',
   title:'Duplicate Files Finder'
  }
 remote.dialog.showMessageBox(options, i => {
  if (i == 1) {
   if (currAppStatus !== OPT.PAUSED){
    resumeApp();
   }
   return;
  }  
  resumeApp();
  walker.send({walker:OPT.RESET});
 })
}
function startApp(){
 addBtn.disabled = true;
 startBtn.disabled = true;
 document
  .querySelectorAll('.delDir, .typeDir')
   .forEach(btn => {
     btn.className += ' disableBtn';
 });
 let obj = {
  walker:OPT.START,
  dirs:dirs
 }
 walker.send(obj);
}

function resumeApp(){
 startBtn.disabled = true;
 let obj = {
  walker:OPT.RESUME
 }
	walker.send(obj);
}

function pauseApp(){
 startBtn.disabled = true;
 let obj = {
  walker:OPT.PAUSE
 }
	walker.send(obj);
}

walker.on('message', (m) => {
	switch (m.walker) {
  case OPT.WEBVIEW:
   webview.executeJavaScript(m.addRows, r => {
    r ? webview.style.height = r : '';
   });
  break;
  case OPT.DIR:
   appStatusBar.innerHTML = '&#128194; '+ m.dir;
  break;
		case OPT.PAUSED:
   appStatus = m.walker;
   startBtn.innerHTML = '<span class="icon-play"></span>Resume';
   startBtn.disabled = false;
   prevStatusBarMsg = appStatusBar.innerHTML;
   appStatusBar.innerHTML = 'Paused';
		break;
		case OPT.STARTED:
   addBtn.innerHTML = '<span class="icon-stop"></span>Cancel';
   addBtn.disabled = false;
   startBtn.disabled = false;
  case OPT.RESUMED:
   appStatus = m.walker;
 		startBtn.innerHTML = '<span class="icon-pause"></span>Pause';
   startBtn.disabled = false;
	 	appStatusBar.innerHTML = prevStatusBarMsg;
		break;
  case OPT.DONE:
   appStatus = m.walker;
   startBtn.innerHTML = 'Finished';
   startBtn.disabled = true;
   addBtn.innerHTML = '<span class="icon-new"></span>New';
   appStatusBar.innerHTML = 'Done &nbsp; &nbsp; Scanned '+m.totalFiles+' files &amp; '+m.totalDirs+' folders';
   prevStatusBarMsg = '';
		break;
	}
});

function dirObject (path){
 this.path       = path;
 this.isIncluded = true;
 dirs.push (this);
 
 pathsDivHead.className = '';
 
 // 8
 let del = document.createElement('span');
 del.className = 'icon-close delDir';

 // 9
 let type = document.createElement('span');
 type.className = 'typeDir';
 type.innerHTML = 'included';

 //10
 let textNode = document.createTextNode(path),

 div = document.createElement('div');
 div.appendChild(del);
 div.appendChild(type);
 div.appendChild(textNode);
 pathsDiv.appendChild(div);

 del.addEventListener('click', () => {
  if (appStatus !== OPT.STOPPED) return;
  pathsDiv.removeChild(div);
  let index = dirs.indexOf(this);

  if (index !== -1)
   dirs.splice(index, 1);

  if (dirs.length === 0 )
   pathsDivHead.className = 'hide';
  })

 type.addEventListener('click', () => {
  if (appStatus !== OPT.STOPPED) return;
  this.isIncluded = !this.isIncluded;

  if (this.isIncluded){
   type.className = 'typeDir';
   type.innerHTML = 'included';
  }
  else {
   type.className = 'typeDir disableBtn';
   type.innerHTML = 'excluded';
  }
 })
}